
;    Developer: Xtreme (Andrew M. Barfield)
;        Email: abarfield@ec.rr.com
;         Date: January 30, 2004
;      Subject: "Longhorn/Whidbey" Popup Menu
; Distribution: Win32ASM Community and MasmForum
;      License: Public/Free
;      Version: 1.1


.386
.model flat, stdcall
option casemap :none
include LWmenus.inc



.code
start:

    push    0
    call    GetModuleHandle
    mov     hInstance, eax

    call    WinMain

    push    0
    call    ExitProcess



WinMain proc

    LOCAL   wc:WNDCLASSEX
    LOCAL   msg:MSG
      
    mov     wc.cbSize, sizeof WNDCLASSEX
    mov     wc.style, CS_BYTEALIGNWINDOW or CS_VREDRAW or CS_HREDRAW
    mov     wc.lpfnWndProc, offset WndProc
    mov     wc.cbClsExtra, 0
    mov     wc.cbWndExtra, 0
    mov     eax, hInstance
    mov     wc.hInstance, eax
    mov     wc.hbrBackground, COLOR_WINDOW+1
    mov     wc.lpszMenuName, NULL
    mov     wc.lpszClassName, offset szClassName
    push    IDI_APPLICATION
    push    hInstance
    call    LoadIcon
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    push    IDC_ARROW
    push    0
    call    LoadCursor
    mov     wc.hCursor, eax
    lea     eax, wc
    push    eax
    call    RegisterClassEx

    push    0
    push    hInstance
    push    0
    push    0
    push    300
    push    450
    push    CW_USEDEFAULT
    push    CW_USEDEFAULT
    push    WS_OVERLAPPEDWINDOW
    push    offset szDisplayName
    push    offset szClassName
    push    0
    call    CreateWindowEx
    mov     hWnd, eax
    
    push    SW_SHOWDEFAULT
    push    hWnd
    call    ShowWindow

    @@:
    	push    0
    	push    0
    	push    0
    	lea     eax, msg
    	push    eax
    	call    GetMessage
    	cmp     eax, 0
    	je      @F
    	lea     eax, msg
    	push    eax
    	call    TranslateMessage
    	lea     eax, msg
    	push    eax
    	call    DispatchMessage
    	jmp     @B

    @@:
    	mov     eax, msg.wParam
    	ret

WinMain endp



WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL   ps:PAINTSTRUCT
    LOCAL   hTempDC:DWORD
    LOCAL   pt:POINT
    LOCAL   rcTemp:RECT
    LOCAL   hmnuIcon:DWORD
    LOCAL   hBmp:DWORD
    LOCAL   nYDest:DWORD



    .if uMsg == WM_CREATE

        ; CREATE A SAMPLE CONTEXT MENU
        call    CreateContextMenu

        ; SAVE OWNERDRAW FONT
        push    DEFAULT_GUI_FONT
        call    GetStockObject 
        mov     hMnuFont, eax

        xor     eax,eax
        ret

    .elseif uMsg == WM_PAINT

        lea     eax, ps
        push    eax
        push    hWnd
        call    BeginPaint
        mov     hTempDC,eax
        
        lea     eax, rcTemp
        push    eax
        push    hWnd
        call    GetClientRect
        mov     eax, 10
        mov     rcTemp.left, eax
        mov     eax, 10
        mov     rcTemp.top, eax

        push    hMnuFont
        push    hTempDC
        call    SelectObject

        push    DT_NOCLIP
        lea     eax, rcTemp
        push    eax
        push    -1
        lea     eax, szWinText
        push    eax
        push    hTempDC
        call    DrawText

        lea     eax, ps
        push    eax
        push    hWnd
        call    EndPaint

        xor     eax, eax
        ret

    .elseif uMsg == WM_RBUTTONDOWN

        ; GET MOUSE POSITION
        mov     eax,lParam
        and     eax,0ffffh
        mov     pt.x,eax
        mov     eax,lParam
        shr     eax,16
        mov     pt.y,eax


        ; CONVERT MOUSE (CLIENT) COORDINATES TO SCREEN (MENU) COORDINATES
        lea     eax, pt
        push    eax
        push    hWin
        call    ClientToScreen


        ; SHOW POPUP MENU
        push    0
        push    hWin
        push    pt.y
        push    pt.x
        push    TPM_LEFTALIGN + TPM_RETURNCMD
        push    hMainMnu
        call    TrackPopupMenuEx


        ; RETURN 0
        xor     eax,eax
        ret

    .elseif uMsg == WM_MEASUREITEM
    
        .if wParam == 0

            mov     edi, lParam
            assume  edi:ptr MEASUREITEMSTRUCT
            mov     [edi].itemWidth, 130

            .if [edi].itemID == 0
                mov     [edi].itemHeight, 3
            .else
                mov     [edi].itemHeight, 24
            .endif

            assume  edi:nothing

        .endif

        mov     eax,1
        ret

    .elseif uMsg == WM_DRAWITEM
    
        .if wParam == 0 ;THIS MESSAGE WAS SENT BY A MENU
                    
            mov     edi, lParam
            assume  edi:ptr DRAWITEMSTRUCT


            ; PREPARE MENU DEVICE CONTEXT
            push    [edi].hdc
            call    SaveDC
            push    TRANSPARENT
            push    [edi].hdc
            call    SetBkMode
            push    hMnuFont
            push    [edi].hdc
            call    SelectObject


            ; FORECOLOR: EITHER ENABLED (BLACK) OR NOT (GRAY)
            .if [edi].itemState & ODS_DISABLED
                push    COLOR_GRAYTEXT
                call    GetSysColor
            .else
                push    COLOR_MENUTEXT
                call    GetSysColor
            .endif
            
            push    eax
            push    [edi].hdc
            call    SetTextColor


            ; DRAW MENU ITEM BACKGROUND
            .if [edi].itemState & ODS_SELECTED

                ; SORRY, COLOR_MENUHIGHLIGHT IS XP SPECIFIC SO I HARD CODED "BABY BLUE"
                push    00EFD3C1h
                call    CreateSolidBrush
                push    eax
                push    [edi].hdc
                call    SelectObject

                push    COLOR_HIGHLIGHT
                call    GetSysColor

                push    eax
                push    1
                push    PS_SOLID
                call    CreatePen
                push    eax
                push    [edi].hdc
                call    SelectObject

                push    [edi].rcItem.bottom
                push    [edi].rcItem.right
                push    [edi].rcItem.top
                push    [edi].rcItem.left
                push    [edi].hdc
                call    Rectangle
                                        
            .else

                ; DRAW "ICON BAR" (LINEAR GRADIENT)
                push    COLOR_MENU
                call    GetSysColor
                mov     edx, offset Color1
                assume  edx:ptr TRIVERTEX
                shl     eax, 8
                mov     [edx].Red, ax
                shr     eax, 16
                shl     eax, 8
                mov     [edx].Green, ax
                shr     eax, 16
                shl     eax, 8
                mov     [edx].Blue, ax
                mov     [edx].Alpha, 0
                mov     eax, [edi].rcItem.left
                mov     [edx].x, eax
                mov     eax, [edi].rcItem.top
                mov     [edx].y, eax

                push    COLOR_BTNFACE
                call    GetSysColor
                mov     edx, offset Color2
                shl     eax, 8
                mov     [edx].Red, ax
                shr     eax, 16
                shl     eax, 8
                mov     [edx].Green, ax
                shr     eax, 16
                shl     eax, 8
                mov     [edx].Blue, ax
                mov     [edx].Alpha, 0
                mov     eax, 24
                mov     [edx].x, eax
                mov     eax, [edi].rcItem.bottom
                mov     [edx].y, eax
                assume  edx:NOTHING

                mov     Grad_Rect.UpperLeft, 0
                mov     Grad_Rect.LowerRight, 1
                push    0
                push    1
                push    offset Grad_Rect
                push    2
                push    offset Color1
                push    [edi].hdc
                call    GradientFill


                ; FILL THE ITEM'S TEXT BACKGROUND
                push    COLOR_MENU
                call    GetSysColorBrush
                push    eax
                push    [edi].hdc
                call    SelectObject
                mov     eax, [edi].rcItem.bottom
                sub     eax, [edi].rcItem.top
                push    PATCOPY
                push    eax
                push    [edi].rcItem.right
                push    [edi].rcItem.top
                push    24
                push    [edi].hdc
                call    PatBlt
                
            .endif	


            ; DRAW CONTENT
            .if [edi].itemID == 0

                push    COLOR_GRAYTEXT
                call    GetSysColor

                push    eax
                push    1
                push    PS_SOLID
                call    CreatePen
                push    eax
                push    [edi].hdc
                call    SelectObject

                inc     [edi].rcItem.top
                push    0
                push    [edi].rcItem.top
                push    30
                push    [edi].hdc
                call    MoveToEx

                push    [edi].rcItem.top
                push    [edi].rcItem.right
                push    [edi].hdc
                call    LineTo

            .elseif [edi].itemState & ODS_CHECKED

                    push    LR_DEFAULTCOLOR
                    push    16
                    push    16
                    push    IMAGE_ICON
                    push    1020                ; CHECK ICON - THIS SHOULD BE REPLACED WITH DrawWindowDodad()
                    push    hInstance           ; (or something like that...)
                    call    LoadImage
                    mov     hmnuIcon, eax

            .else
  
                    push    LR_DEFAULTCOLOR
                    push    16
                    push    16
                    push    IMAGE_ICON
                    push    [edi].itemID
                    push    hInstance
                    call    LoadImage
                    mov     hmnuIcon, eax
               
            .endif


            .if hmnuIcon != 0

                mov     eax, [edi].rcItem.top
                add     eax, 4
                mov     nYDest, eax

                .if [edi].itemState & ODS_DISABLED

                    ; CREATE A 16x16 PIXEL MEMDC TO LOAD OUR ICON ONTO
                    push    [edi].hdc
                    call    CreateCompatibleDC
                    mov     hTempDC, eax
                    push    16
                    push    16
                    push    [edi].hdc
                    call    CreateCompatibleBitmap
                    mov     hBmp, eax
                    push    hBmp
                    push    hTempDC
                    call    SelectObject                    


                    ; MAKE THE BACKGROUND PINK - ITS THE TRANSPARENT COLOR
                    push    00C080FFh
                    call    CreateSolidBrush
                    push    eax
                    push    hTempDC
                    call    SelectObject
                    push    PATCOPY
                    push    16
                    push    16
                    push    0
                    push    0
                    push    hTempDC
                    call    PatBlt                    


                    ; DRAW THE ICON ONTO THE PINK, TEMPORARY, 16x16, MEMDC            
                    push    DI_NORMAL
                    push    0
                    push    0
                    push    16
                    push    16
                    push    hmnuIcon
                    push    0
                    push    0
                    push    hTempDC
                    call    DrawIconEx
                    

                    ; GRAYSCALE THE ICON BUT IGNORE THE PINK BACKGROUND
                    push    00C080FFh
                    push    hTempDC
                    push    16
                    push    16
                    call    GrayScale


                    ; BITBLT OUR MEMDC ONTO THE MENU (EXCEPT FOR THE PINK BACKGROUND)
                    push    00C080FFh
                    push    16
                    push    16
                    push    0
                    push    0
                    push    hTempDC
                    push    16
                    push    16
                    push    nYDest
                    push    3
                    push    [edi].hdc
                    call    TransparentBlt


                    ; CLEAN THIS MESS UP!
                    push    hBmp
                    call    DeleteObject
                    push    hTempDC
                    call    DeleteDC

                .else
           
                        push    DI_NORMAL
                        push    0
                        push    0
                        push    16
                        push    16
                        push    hmnuIcon
                        push    nYDest
                        push    3
                        push    [edi].hdc
                        call    DrawIconEx

                .endif
                                                
            .endif


            mov     eax, 30
            mov     [edi].rcItem.left, eax
            push    [edi].itemData
            call    lstrlen
            mov     [edi].itemAction, eax

            push    DT_SINGLELINE or DT_NOCLIP or DT_VCENTER
            lea     eax, [edi].rcItem
            push    eax
            push    [edi].itemAction
            push    [edi].itemData
            push    [edi].hdc
            call    DrawText

            push    -1
            push    [edi].hdc
            call    RestoreDC

            push    hmnuIcon
            call    DestroyIcon

            assume  edi:nothing
        .endif

        mov eax,1
        ret

    .elseif uMsg == WM_DESTROY

        push    hMnuFont
        call    DeleteObject

        push    0
        call    PostQuitMessage

        xor eax,eax
        ret

    .endif

    push    lParam
    push    wParam
    push    uMsg
    push    hWin
    call    DefWindowProc

    ret

WndProc endp



CreateContextMenu proc

    call    CreatePopupMenu
    mov     hMainMnu, eax

    ;THIS IS JUST A SAMPLE SO I'LL BE LAZY AND USE "INVOKE" AND "APPENDMENU"

    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_ENABLED, ID_MNU_SETUP, ADDR szMnuSetup
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_SEPARATOR, 0, 0
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_ENABLED, ID_MNU_START, ADDR szMnuStart
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_DISABLED, ID_MNU_PAUSE, ADDR szMnuPause
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_DISABLED, ID_MNU_STOP, ADDR szMnuStop
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_ENABLED, ID_MNU_CATCHUP, ADDR szMnuCatchUp
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_SEPARATOR, 0, 0
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_DISABLED, ID_MNU_SLIDESHOW, ADDR szMnuSlide
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_ENABLED, ID_MNU_SCHEDULE, ADDR szMnuSchedule
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_SEPARATOR, 0, 0
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_ENABLED, ID_MNU_FEEDBACK, ADDR szMnuFeedback
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_SEPARATOR, 0, 0
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_ENABLED, ID_MNU_ABOUT, ADDR szMnuAbout
    invoke AppendMenu, hMainMnu, MF_OWNERDRAW or MF_ENABLED, ID_MNU_HELP, ADDR szMnuHelp

    xor     eax,eax
    ret
    
CreateContextMenu endp





; SPECIAL THANKS TO DONKEY (HTTP://DONKEY.VISUALASSEMBLER.COM/) FOR THIS GRAYSCALE ROUTINE
; I HAVE MODIFIED IT TO ACCEPT A DC AS A PARAMETER AND I HAVE INTRODUCED A TRANSPARENT
; COLOR SO OUR GRAYED ICON'S SOLID BACKGROUND CAN BE REMOVED (TRANSPARENTBLT)

GrayScale proc uses edi esi imageX:DWORD, imageY:DWORD, hMemDC:DWORD, ClrTransparent:DWORD
    LOCAL   red:DWORD 
    LOCAL   green:DWORD 
    LOCAL   blue:DWORD 

    mov     edi,imageX 
    dec     edi 
    mov     esi,imageY 
    dec     esi
     
    .REPEAT 
        .REPEAT

            push    esi
            push    edi
            push    hMemDC
            call    GetPixel

            .if eax != ClrTransparent

                movzx   ecx,al   ; red 
                imul    ecx,ecx,66 
                movzx   edx,ah   ; green 
                imul    edx,edx,129 
                add     edx,ecx 
                shr     eax,16   ; blue 
                imul    eax,eax,25 
                add     eax,edx 
                add     eax,128 
                shr     eax,8 
                add     eax,16 
                imul    eax, eax, 010101h

                push    eax
                push    esi
                push    edi
                push    hMemDC
                call    SetPixelV

            .endif
 
            dec esi 
        .UNTIL SIGN?
         
        mov esi,imageY 
        dec esi 
        dec edi 
    .UNTIL SIGN? 

   ret 

GrayScale endp

end start
